/* "number" is an array of digits representing a big integer, where the
   low-order digit is stored at the last index.  For example, the number
   1234567 is stored as pictured here:
        ______________________________________
         |   |   |   |   |   |   |   |   |   |
    ...  | 0 | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 |
        _|___|___|___|___|___|___|___|___|___|

   "digit" is a digit (between 0 and 9 inclusive).  The function multiplies
   "number" by "digit" and stores the result in "result".  Both "number"
   and "result" must be at least 100 digits long.  The function assumes that
   the "result" array is large enough to hold the answer, that "digit" is
   really a digit 0--9, and that "number" contains only digits 0--9. */

void scale (int number[], int digit, int result[]) {
  
  int i;
  int prod, carry;
  const int length = 100;

  carry = 0;
  for (i = length-1; i >= 0; i--) {
    prod = (number[i] * digit) + carry;
    result[i] = prod % 10;
    carry = prod / 10;
  }

}
