{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 168{COM_R 2 0{TEXT 1 22 "Arithmetic Expres
sions"}}{COM_R 3 0{TEXT 1 373 "\015This worksheet is designed to \+
accompany Chapter 2 of \"Introduction to Scientific Programming: \+
Computational Problem Solving Using Maple and C\" by Joseph L. Za
chary.  In it, we will explore the use of basic arithmetic expres
sions in Maple.  We will also explore some of the differences bet
ween the rational and floating-point numbers that are supplied by
 Maple.  (24Sep96)\015"}}{SEP_R 4 0}{SEP_R 5 0}{COM_R 6 0{TEXT 1 
295 "\015Numbers.  As you already know, you interact with Maple b
y entering a command and looking at the value that Maple then dis
plays.  The simplest kind of command is a number.  When you enter
 it, Maple echoes its value, which is the number itself.  There a
re various ways to write numbers in Maple.\015"}}{SEP_R 7 0}
{COM_R 8 0{TEXT 1 76 "\015There are integers, which are written w
ithout decimal points or exponents:\012"}}{INP_R 9 0 "> "{TEXT 0 
4 "154;"}}{COM_R 10 0{TEXT 1 67 "\012There are fractions, which a
re written as ratios of two integers:\012"}}{INP_R 11 0 "> "{TEXT
 0 5 "4/16;"}}{COM_R 12 0{TEXT 1 65 "\012Integers and fractions a
re collectively called rational numbers."}}{COM_R 13 0{TEXT 1 74 
"\015There are floating-point numbers, which are written with dec
imal points:\012"}}{INP_R 14 0 "> "{TEXT 0 7 "152.35;"}}{COM_R 15
 0{TEXT 1 71 "\012Floating-point numbers can also be written usin
g scientific notation:\012"}}{INP_R 16 0 "> "{TEXT 0 10 "152.35e1
5;"}}{COM_R 17 0{TEXT 1 161 "\012The \"e15\" part means \"times 1
0 to the 15th power\".  Notice that the result is also written in
 scientific notation, although the appearance is more conventiona
l."}}{COM_R 18 0{TEXT 1 108 "\015A number with an exponent is tre
ated as a floating-point number, even if it does not have a decim
al point:\012"}}{INP_R 19 0 "> "{TEXT 0 9 "15235e13;"}}{COM_R 20 
0{TEXT 1 113 "\012Maple reminds us that this is a floating-point \+
number by putting a decimal point in the value that it displays.\
015"}}{SEP_R 21 0}{COM_R 22 0{TEXT 1 79 "\015Exercises.  At the p
rompts provided, enter rational numbers that are equal to:"}}
{COM_R 23 0{TEXT 1 11 "\015(1)  175.\012"}}{INP_R 24 0 "> "{TEXT 
0 0 ""}}{COM_R 25 0{TEXT 1 11 "\012(2)  17.5\012"}}{INP_R 26 0 ">
 "{TEXT 0 0 ""}}{COM_R 27 0{TEXT 1 13 "\012(3)  175e-3\012"}}
{INP_R 28 0 "> "{TEXT 0 0 ""}}{COM_R 29 0{TEXT 1 73 "\012At the p
rompts provided, enter floating-point numbers that are equal to:"
}}{COM_R 30 0{TEXT 1 9 "\015(4)  16\012"}}{INP_R 31 0 "> "{TEXT 0
 0 ""}}{COM_R 32 0{TEXT 1 11 "\012(5)  1/16\012"}}{INP_R 33 0 "> \+
"{TEXT 0 0 ""}}{COM_R 34 0{TEXT 1 12 "\012(6)  5 1/4\012"}}{INP_R
 35 0 "> "{TEXT 0 0 ""}}{COM_R 36 0{TEXT 1 0 ""}}{SEP_R 37 0}
{SEP_R 38 0}{COM_R 39 0{TEXT 1 253 "\015Simple Expressions.  Numb
ers can be combined with the five arithmetic operations of additi
on (+), subtraction (-), multiplication (*), division (/), and ex
ponentiation (^).  They are used in exactly the way with which yo
u are familiar from arithmetic.\015"}}{SEP_R 40 0}{COM_R 41 0
{TEXT 1 30 "\015We add two rational numbers:\012"}}{INP_R 42 0 ">
 "{TEXT 0 9 "115 + 72;"}}{COM_R 43 0{TEXT 1 41 "\012We subtract t
wo floating-point numbers:\012"}}{INP_R 44 0 "> "{TEXT 0 13 "191.
3 - 72.3;"}}{COM_R 45 0{TEXT 1 35 "\012We multiply two rational n
umbers:\012"}}{INP_R 46 0 "> "{TEXT 0 25 "18723474387 * 239872349
7;"}}{COM_R 47 0{TEXT 1 41 "\012We multiply two floating-point nu
mbers:\012"}}{INP_R 48 0 "> "{TEXT 0 27 "18723474387. * 239872349
7.;"}}{COM_R 49 0{TEXT 1 281 "\012Compare the results of the two \+
multiplications.  When Maple operates on rational numbers, it giv
es an exact result no matter how many digits are required.  When \+
Maple operates on two floating-point numbers, it gives the answer
 in scientific notation rounded to ten decimal places."}}{COM_R 
50 0{TEXT 1 33 "\015We divide two rational numbers:\012"}}{INP_R 
51 0 "> "{TEXT 0 17 "8383832 / 283742;"}}{COM_R 52 0{TEXT 1 39 "\
012We divide two floating-point numbers:\012"}}{INP_R 53 0 "> "
{TEXT 0 19 "8383832. / 283742.;"}}{COM_R 54 0{TEXT 1 139 "\012Aga
in, notice that Maple gives exact results for the rational divisi
on and a result rounded to ten digits for the floating-point divi
sion."}}{COM_R 55 0{TEXT 1 39 "\015We exponentiate two rational n
umbers:\012"}}{INP_R 56 0 "> "{TEXT 0 8 "2 ^ 100;"}}{COM_R 57 0
{TEXT 1 45 "\012We exponentiate two floating-point numbers:\012"}
}{INP_R 58 0 "> "{TEXT 0 10 "2. ^ 100.;"}}{COM_R 59 0{TEXT 1 0 ""
}}{SEP_R 60 0}{COM_R 61 0{TEXT 1 119 "\012Exercises.  At the prom
pts, compute the following values.  Are the results rational numb
ers or floating-point numbers?"}}{COM_R 62 0{TEXT 1 94 "\015(7)  \+
The number of inches in a mile (there are 5280 feet in a mile and
 12 inches in a foot).\012"}}{INP_R 63 0 "> "{TEXT 0 0 ""}}{COM_R
 64 0{TEXT 1 68 "\012(8)  The number of bytes in a megabyte (it's
 2 to the 20th power).\012"}}{INP_R 65 0 "> "{TEXT 0 0 ""}}{COM_R
 66 0{TEXT 1 76 "\012(9)  The number of inches in a meter (there \+
are .0254 meters in an inch).  "}}{INP_R 67 0 "> "{TEXT 0 0 ""}}
{COM_R 68 0{TEXT 1 89 "\012(10)  The difference between your heig
ht in feet and your best friend's height in feet.\012"}}{INP_R 69
 0 "> "{TEXT 0 0 ""}}{COM_R 70 0{TEXT 1 87 "\012(11)  The combine
d weight of you and George Foreman (let's say he weighs 260 pound
s).\012"}}{INP_R 71 0 "> "{TEXT 0 0 ""}}{COM_R 72 0{TEXT 1 0 ""}}
{SEP_R 73 0}{SEP_R 74 0}{COM_R 75 0{TEXT 1 277 "Mixed Expressions
.  If an expression contains a mixture of rational and floating-p
oint numbers, Maple first converts the rational number into float
ing-point form and then does the operation.  Compare the results \+
of the following operations to the ones in the previous section.\
015"}}{SEP_R 76 0}{COM_R 77 0{TEXT 1 60 "\015We multiply a ration
al number and a floating-point number:\012"}}{INP_R 78 0 "> "
{TEXT 0 26 "18723474387 * 2398723497.;"}}{COM_R 79 0{TEXT 1 58 "\
012We divide a floating-point number and a rational number:\012"}
}{INP_R 80 0 "> "{TEXT 0 18 "8383832. / 283742;"}}{COM_R 81 0
{TEXT 1 64 "\012We exponentiate a floating-point number and a rat
ional number:\012"}}{INP_R 82 0 "> "{TEXT 0 9 "2. ^ 100;"}}{COM_R
 83 0{TEXT 1 115 "\012In each case, the result is the same as it \+
would have been if both of the numbers had been floating-point nu
mbers."}}{COM_R 84 0{TEXT 1 0 ""}}{SEP_R 85 0}{COM_R 86 0{TEXT 1 
475 "\015Exercises.  We have been careful not to make any mistake
s in our expressions to this point, but they will be very common \+
when you experiment with Maple.  Mistakes can be things like forg
etting an operator symbol, forgetting a panthesis, putting in too
 many parentheses, and the like.\012\015\033Maple tries to explai
n what is wrong, but the explanations are not\012always clear.  U
se Maple to evaluate each of the expressions below, and then corr
ect the syntax error that Maple reports."}}{COM_R 87 0{TEXT 1 29 
"\015(12)  Average of 16 and 39.\012"}}{INP_R 88 0 "> "{TEXT 0 15
 "0.5 * (16 + 39;"}}{COM_R 89 0{TEXT 1 27 "\012(13)  Sum of 100 a
nd 200.\012"}}{INP_R 90 0 "> "{TEXT 0 11 "10 0 + 200;"}}{COM_R 91
 0{TEXT 1 42 "\012(14)  Product of first ten even numbers.\012"}}
{INP_R 92 0 "> "{TEXT 0 42 "2 * 4 * 6 * 8 * 10 12 * 14 * 16 * 18 \+
* 20;"}}{COM_R 93 0{TEXT 1 37 "\012(15)  11 raised to the 11th po
wer. \015"}}{INP_R 94 0 "> "{TEXT 0 8 "11 & 11;"}}{COM_R 95 0
{TEXT 1 0 ""}}{SEP_R 96 0}{SEP_R 97 0}{COM_R 98 0{TEXT 1 256 "\01
5Compound Expressions.  Just as in arithmetic, more than one oper
ation can be carried out in a single expression.  The order in wh
ich the operations are carried out depends both on the way they a
re grouped with parentheses and on Maple's precedence rules.\015"
}}{SEP_R 99 0}{COM_R 100 0{TEXT 1 42 "\015Here we take the averag
e of two numbers:\012"}}{INP_R 101 0 "> "{TEXT 0 15 "(158 + 64) /
 2;"}}{COM_R 102 0{TEXT 1 217 "\012Notice that parentheses are us
ed, just as in mathematics, to indicate the order in which operat
ions are carried out.  In the absence of parentheses, the operati
ons are not necessarily carried out from left to right:\012"}}
{INP_R 103 0 "> "{TEXT 0 13 "158 + 64 / 2;"}}{COM_R 104 0{TEXT 1 
342 "\012In the absence of parentheses, the division was performe
d first, followed by the addition.  Once you have learned Maple's
 precedence rules, you will be able to predict the order in which
 arithmetic operations will be carried out.  We will not discuss \+
precedence rules in this worksheet.  You should use parentheses w
henever you are in doubt."}}{COM_R 105 0{TEXT 1 163 "\015In a com
pound expression, a rational number is converted to floating-poin
t form whenever it is involved in an operation with a floating-po
int number.  Consider:\012 "}}{INP_R 106 0 "> "{TEXT 0 17 "(158 +
 64) / 2.0;"}}{COM_R 107 0{TEXT 1 217 "\012The addition involves \+
two rational numbers, so rational number addition is done.  The s
um is then converted to floating-point form so that it can be div
ided by a floating-point number.  On ther other hand, consider:\0
12"}}{INP_R 108 0 "> "{TEXT 0 16 "(158. + 64) / 2;"}}{COM_R 109 0
{TEXT 1 259 "\012The sum involves a floating-point and a rational
 number, so the rational number is first converted to floating-po
int form.  The sum is a floating-point number, so the divisor mus
t be converted into floating-point form before the division can b
e carried out.\015"}}{SEP_R 110 0}{SEP_R 111 0}{COM_R 112 0{TEXT 
1 177 "\015Exercises.\012\012(16)  Write an expression to calcula
te the number of centimeters in a mile.  (There are 5280 feet in \+
a mile, 12 inches in a foot, and 2.54 centimeters in an inch.)\01
2"}}{INP_R 113 0 "> "{TEXT 0 0 ""}}{COM_R 114 0{TEXT 1 175 "\012(
17)  Write an expression to compute the grade point average of a \+
class of 11 students, where 4 make an A (4.0), 3 make a B+ (3.3),
 3 make a C (2.0), and 1 makes a C- (1.7).\012"}}{INP_R 115 0 "> \+
"{TEXT 0 0 ""}}{COM_R 116 0{TEXT 1 235 "\012(18)  In some situati
ons, the order in which conversions from rational to floating-poi
nt numbers are carried out in a compound expression can make a di
fference.  Explain why the results of the following two expressio
ns are different.\012"}}{INP_R 117 0 "> "{TEXT 0 24 "1.0 * (1/3 +
 1/3 + 1/3);"}}{INP_R 118 0 "> "{TEXT 0 24 "(1.0 * 1/3) + 1/3 + 1
/3;"}}{COM_R 119 0{TEXT 1 0 ""}}{SEP_R 120 0}{SEP_R 121 0}{COM_R 
122 0{TEXT 1 334 "\015Function Application.  Besides the five ari
thmetic operators, Maple provides many built-in functions that op
erate on numbers.  Whereas operator symbols are written between t
he numbers that they operate on (their parameters), built-in func
tion names are written in front of their parameters, just as is t
he convention in mathematics.\015"}}{SEP_R 123 0}{COM_R 124 0
{TEXT 1 135 "\015The \"evalf\" function expects one parameter, wh
ich is typically a rational number, and produces the closest floa
ting-point equivalent:\012"}}{INP_R 125 0 "> "{TEXT 0 11 "evalf(1
/7);"}}{COM_R 126 0{TEXT 1 121 "\012The \"sqrt\" function produce
s the square root of its parameter.  We can take the square root \+
of a floating-point number:\012"}}{INP_R 127 0 "> "{TEXT 0 11 "sq
rt(18.0);"}}{COM_R 128 0{TEXT 1 26 "\012Or of a rational number:\
012"}}{INP_R 129 0 "> "{TEXT 0 9 "sqrt(18);"}}{COM_R 130 0{TEXT 1
 199 "\012Notice how the square root of a floating-point number i
s written as a ten-digit approximation whereas the square root of
 a rational number is written exactly, even if it requires a radi
cal to do so."}}{COM_R 131 0{TEXT 1 138 "\015Just as we can write
 expressions with more than one arithmetic operation, we can writ
e expressions with more than one built-in function:\012"}}{INP_R 
132 0 "> "{TEXT 0 16 "evalf(sqrt(18));"}}{COM_R 133 0{TEXT 1 95 "
\012This takes the square root of a rational number and then conv
erts it into floating-point form."}}{COM_R 134 0{TEXT 1 44 "\015T
his expression amounts to the same thing:\012"}}{INP_R 135 0 "> "
{TEXT 0 17 "evalf(sqrt(9+9));"}}{COM_R 136 0{TEXT 1 107 "\012The \+
\"cos\" function produces the cosine of its parameter.  (The para
meter should be expressed in radians.)\012"}}{INP_R 137 0 "> "
{TEXT 0 21 "cos(3.141592654 / 3);"}}{COM_R 138 0{TEXT 1 263 "\012
Some functions take more than one parameter.  For example, \"eval
f\" will take an optional second argument, which should be an int
eger.  The second parameter specifies the number of digits that s
hould appear in the mantissa of the resulting floating-point numb
er:\012"}}{INP_R 139 0 "> "{TEXT 0 14 "evalf(1/7, 5);"}}{COM_R 
140 0{TEXT 1 99 "\012Notice that when more than one parameter is \+
passed to a function, they are separated with commas.\015"}}
{SEP_R 141 0}{COM_R 142 0{TEXT 1 58 "\015Exercises.  At the promp
ts, compute the following values."}}{COM_R 143 0{TEXT 1 63 "\015(
19)  The exact sum of the square roots of 1, 2, 3, 4, and 5.\012"
}}{INP_R 144 0 "> "{TEXT 0 0 ""}}{COM_R 145 0{TEXT 1 56 "\012(20)
  A floating-point approximation to the sum above.\012"}}{INP_R 
146 0 "> "{TEXT 0 0 ""}}{COM_R 147 0{TEXT 1 106 "\012(21)  The sq
uare root of the sum of the sine and the cosine of 1/4 Pi.\012 (U
se a value of 3.14159 for Pi.)\012"}}{INP_R 148 0 "> "{TEXT 0 0 "
"}}{COM_R 149 0{TEXT 1 0 ""}}{SEP_R 150 0}{SEP_R 151 0}{COM_R 152
 0{TEXT 1 212 "\015Help With Functions.  There are so many functi
ons built into Maple that it is virtually impossible to remember \+
them all.  Fortunately, Maple provides a powerful help facility. \+
 There are several ways to use it.\015"}}{SEP_R 153 0}{COM_R 154 
0{TEXT 1 301 "\015If you happen to know the name of a function an
d wish to know more about it, you can ask Maple to display help i
nformation for it.  For example, let's see what Maple can tell us
 about the \"sqrt\" function.  To ask for help, issue a command c
onsisting of a question mark followed by the function name.\012"}
}{INP_R 155 0 "> "{TEXT 0 5 "?sqrt"}}{COM_R 156 0{TEXT 1 212 "\01
2A help window will appear containing information about \"sqrt\".
  A help window will contain a brief explanation followed by some
 examples.  The help for \"sqrt\" tells us that it works even for
 negative parameters."}}{COM_R 157 0{TEXT 1 21 "\015Let's try tha
t out.\012"}}{INP_R 158 0 "> "{TEXT 0 10 "sqrt(-18);"}}{COM_R 159
 0{TEXT 1 61 "\012Here, the \"I\" tells us that the result is a c
omplex  number."}}{COM_R 160 0{TEXT 1 737 "\015If you know what k
ind of function you need but you're not sure what Maple calls it,
 Maple can also be of help.  For eample, suppose that we'd like t
o find a function that will produce the prime factorization of an
 integer.  Pull down the \"Help\" menu in the upper right-hand co
rner and choose the \"Keyword Search\" option.  Enter \"integer f
actorization\" in the box labeled \"Search For String\" and click
 on \"Search\".  A window of functions having the words \"integer
 factorization\" in their descriptions will be displayed.  Near t
he top of the list you'll find a likely function called \"ifactor
\".   If you click on its description and then click on \"Help\",
 its help window will appear.  It turns out that this is just the
 function we need.\012"}}{INP_R 161 0 "> "{TEXT 0 14 "ifactor(979
2);"}}{COM_R 162 0{TEXT 1 558 "\015Finally, Maple will help you e
xplore even if you have no idea what you're looking for.  Pull do
wn the \"Help\" menu again, but this time choose the \"Help Brows
er\" option.  When you select one of the topics displayed, Maple \+
will display a variety of subtopics.  For example, selecting \"Ma
thematics\" displays some subtopics.  Selecting \"Algebra\" displ
ays more subtopics.  Selecting \"Rational Expressions\" displays \+
still more subtopics.  Finally, selecting \"denom,\" which is a b
uilt-in function, and then clicking on \"Help\" displays the help
 window for \"denom\".\012"}}{INP_R 163 0 "> "{TEXT 0 12 "denom(3
/15);"}}{COM_R 164 0{TEXT 1 0 ""}}{SEP_R 165 0}{COM_R 166 0{TEXT 
1 166 "\012Exercises.\015\015(22) Use Maple's help facility to fi
nd a way to compute the base 2 logarithm of a number.  (The base \+
2 logarithm of 16 is 4 and of 19.2 is 4.263034406.)\015"}}{INP_R 
167 0 "> "{TEXT 0 0 ""}}{COM_R 168 0{TEXT 1 0 ""}}{SEP_R 169 0}}
{END}
