{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 70{COM_R 2 0{TEXT 1 270 "Operator Preceden
ce\015\015This woksheet is designed to accompany Chapter 3 of Int
roduction to Scientific Programming: Computational Problem Solvin
g Using Maple and C by Joseph L. Zachary.  In it, we will use Map
le to explore the concept of operator precedence.  (AW, Jan 97)\0
15"}}{SEP_R 3 0}{SEP_R 4 0}{COM_R 5 0{TEXT 1 369 "\015Multiplicat
ion/Division vs. Addition/Subtraction.  Examine the Maple express
ion below.  Try to predict what its value will be before you ask \+
Maple to evaluate it.  There seem to be two possibilities.  If th
e addition is performed first, the result will be 4/2, which is 2
.  If the division is performed first the result will be 5/2.  Wh
ich is it?  Try it out and see.\012"}}{INP_R 6 0 "> "{TEXT 0 6 "1
+3/2;"}}{COM_R 7 0{TEXT 1 125 "\012The second possibility was cor
rect: the division was performed first.  We say  that division ta
kes precedence over addition."}}{COM_R 8 0{TEXT 1 110 "\015Now co
nsider this expression.  What are two reasonable possible values?
  Which do you think Maple will find?\012"}}{INP_R 9 0 "> "{TEXT 
0 6 "2-3*4;"}}{COM_R 10 0{TEXT 1 201 "\012Here, the multiplicatio
n was performed prior to the subtraction.  (Had the subtraction b
een performed first, the answer would have been -4.)  We say that
 multiplication takes precedence over addition."}}{COM_R 11 0
{TEXT 1 185 "\015Now try the following experiments:\012\012* In t
he first expression above, replace the + operator with a - operat
or and reevaluate.  Which operator takes precedence, subtraction \+
or division?"}}{COM_R 12 0{TEXT 1 153 "\015* In the second expres
sion above, replace the - operator with a + operator and reevalua
te.  Which operator takes precedence, addition or multiplication?
"}}{COM_R 13 0{TEXT 1 274 "\015Your experiments should reveal tha
t in Maple (as in most other programming languages) multiplicatio
n and division take precedence over addition and subtraction.  We
 say that multiplication and division are at a higher level of pr
ecedence than are addition and subtraction.\015"}}{SEP_R 14 0}
{COM_R 15 0{TEXT 1 253 "\015Multiplication vs. Division and Addit
ion vs. Subtraction.  What happens when an expression involves mo
re than operator at the same level of precedence?  (For example, \+
more than one multiplication and division or more than one additi
on and subtraction.)"}}{COM_R 16 0{TEXT 1 56 "\015What would be t
wo possible values for this expression?\012"}}{INP_R 17 0 "> "
{TEXT 0 6 "2/3*4;"}}{COM_R 18 0{TEXT 1 199 "\012The division was \+
performed first (to obtain 2/3), and the result was then multipli
ed by 4 (to obtain 8/3).  Had the multiplication been performed b
efore the division, the result would have been 1/6."}}{COM_R 19 0
{TEXT 1 232 "\015This does not mean that multiplication takes pre
cedence over division, however.  In the absence of parentheses, m
ultiplication and division are performed left to right.  We say t
hat multiplication and division are left associative."}}{COM_R 20
 0{TEXT 1 197 "\015Try to predict the outcome of each of the foll
owing calculations before you try it.  If your prediction turns o
ut to be incorrect, be sure to figure out where the flaw in your \+
reasoning occurred.\012"}}{INP_R 21 0 "> "{TEXT 0 6 "2*3/4;"}}
{COM_R 22 0{TEXT 1 0 ""}}{INP_R 23 0 "> "{TEXT 0 6 "2/3/4;"}}
{COM_R 24 0{TEXT 1 0 ""}}{INP_R 25 0 "> "{TEXT 0 8 "4/3*2/5;"}}
{COM_R 26 0{TEXT 1 0 ""}}{INP_R 27 0 "> "{TEXT 0 8 "6*3/4*5;"}}
{COM_R 28 0{TEXT 1 300 "\012Addition and subtraction are also lef
t associative.  In the absence of parentheses, addition and multi
plication is performed from left to right.  In rational arithmeti
c (at least in the absence of overlow) this does not make any dif
ference, but in floating-point arithmetic it can become important
. "}}{COM_R 29 0{TEXT 1 156 "\015The following two expressions ar
e mathematically identical; they differ only in the fact that the
ir last two terms have been interchanged.  Evaluate them.\012"}}
{INP_R 30 0 "> "{TEXT 0 14 "1 - 1 + 1e-12;"}}{COM_R 31 0{TEXT 1 2
 " \012"}}{INP_R 32 0 "> "{TEXT 0 14 "1 + 1e-12 - 1;"}}{COM_R 33 
0{TEXT 1 36 "\012The answers are not the same!  Why?"}}{COM_R 34 
0{TEXT 1 158 "\015In the first expression, the subtraction is per
formed first and the result is zero.  When zero is added to the n
umber 1e-12, we end up with the result 1e-12."}}{COM_R 35 0{TEXT 
1 309 "\015In the second expression, the addition is performed fi
rst.  With only ten digits of mantissa, however, the number 1e-12
 is the lost in the roundoff and the result is 1.  The subtractio
n thus yields a result of zero.  (This example shows that floatin
g-point arithmetic need not satisfy the associative rule.)\015"}}
{SEP_R 36 0}{COM_R 37 0{TEXT 1 154 "\015Exponentiation.  What abo
ut the precedence of the exponentiation operator?   See if you ca
n figure out the rule by evaluating the following expressions:\01
2"}}{INP_R 38 0 "> "{TEXT 0 6 "4*3^2;"}}{COM_R 39 0{TEXT 1 0 ""}}
{INP_R 40 0 "> "{TEXT 0 6 "1+3^2;"}}{COM_R 41 0{TEXT 1 0 ""}}
{INP_R 42 0 "> "{TEXT 0 6 "5/2^3;"}}{COM_R 43 0{TEXT 1 0 ""}}
{INP_R 44 0 "> "{TEXT 0 9 "3/10^3*7;"}}{COM_R 45 0{TEXT 1 260 "\0
12Notice that in each of these examples, the exponentiation was p
erformed first.  This is indeed the way that it works: exponentia
tion has higher precedence than multiplication and division, whic
h in turn have higher precedence than addition and multiplication
."}}{COM_R 46 0{TEXT 1 26 "\015Now try this expression.\012"}}
{INP_R 47 0 "> "{TEXT 0 6 "2^3^4;"}}{COM_R 48 0{TEXT 1 171 "\012T
he exponentiation operator is non-associative.  If you wish to do
 more than one exponentiation in an expression, you must use pare
ntheses to tell Maple whether you want\012"}}{INP_R 49 0 "> "
{TEXT 0 8 "(2^3)^4;"}}{COM_R 50 0{TEXT 1 4 "\012or\012"}}{INP_R 
51 0 "> "{TEXT 0 8 "2^(3^4);"}}{COM_R 52 0{TEXT 1 0 ""}}{SEP_R 53
 0}{COM_R 54 0{TEXT 1 294 "\015Parentheses.  Speaking of parenthe
ses, you can override Maple's precedence rules by using parenthes
es to group expressions in the order that you wish Maple to evalu
ate them.  Here are some examples where we use parentheses to for
ce a different evaluation order than Maple would otherwise use.\0
12"}}{INP_R 55 0 "> "{TEXT 0 8 "2*(3+4);"}}{COM_R 56 0{TEXT 1 0 "
"}}{INP_R 57 0 "> "{TEXT 0 8 "2^(3*4);"}}{COM_R 58 0{TEXT 1 0 ""}
}{INP_R 59 0 "> "{TEXT 0 8 "2/(3/3);"}}{COM_R 60 0{TEXT 1 119 "\0
12If you have any doubt, use parentheses to make sure Maple execu
tes your expressions in the order in which you intend.\015"}}
{SEP_R 61 0}{COM_R 62 0{TEXT 1 641 "\015Summary.\015\015* There a
re five arithmetic operators:  ^, *, /, +, and -.\015\015* Expone
ntiation (^) is at the highest level of precedence, multiplicatio
n (*) and division (/) are at a lower level of precedence, and ad
dition (+) and subtraction (-) are at an even lower level of prec
edence.\015\015* In the absence of parentheses, operators at a hi
gher level of precedence are performed before operators at a lowe
r level of precedence.\015\015* In the absence of parentheses, mu
ltiplication and division are performed from left to right, as ar
e addition and subtraction.\015\015* Parentheses can be used to e
xplicitly control the order of evaluation of an expression.\015"}
}{SEP_R 63 0}{COM_R 64 0{TEXT 1 54 "Exercises.\015\015 1.  Evalua
te the following expression. \015 "}}{INP_R 65 0 "> "{TEXT 0 10 "
2 - 2^3*2;"}}{COM_R 66 0{TEXT 1 210 "\012Add one set of parenthes
es so that the expression evalutes to -12.  Now move your parenth
eses so that the expression evaluates to -62.  Move your parenthe
ses one last time to make the expression evaluate to 0."}}{COM_R 
67 0{TEXT 1 43 "\0152.   Evaluate the following expression. \015 \+
"}}{INP_R 68 0 "> "{TEXT 0 8 "2/3*4^2;"}}{COM_R 69 0{TEXT 1 161 "
\012Add two sets of parentheses that leave the value of the expre
ssion unchanged.  (Your parentheses may enclose neither the entir
e expression nor a single number.)"}}{COM_R 70 0{TEXT 1 44 "\0153
.  Repeat exercise 2 for this expression.\012"}}{INP_R 71 0 "> "
{TEXT 0 10 "1+2/3*4+5;"}}}{END}
