{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 74{COM_R 2 0{TEXT 1 429 "Plotting.\015\015
This worksheet is designed to accompany Chapter 7 of Introduction
 to Scientific Programming: Computational Problem Solving Using M
aple and C by Joseph L. Zachary.  In it, we will look at the plot
ting examples from Chapter 7 and show how to use optional paramet
ers to embellish the plots.  Be sure to  experiment with the menu
s at the top \012of the plot windows, as they can change the plot
's appearance in various ways.\012"}}{SEP_R 3 0}{SEP_R 4 0}{COM_R
 5 0{TEXT 1 92 "\015Getting Started.\015\015We'll begin by defini
ng the horizontal, vertical, and duration functions."}}{COM_R 6 0
{TEXT 1 271 "\015(7.9)  We create a function \"horizontal\" that \+
returns the horizonal position in meters of a projectile \"t\" se
conds after it is fired with initial speed \"V\" m/sec and initia
l angle \"theta\" radians.  This function ignores what happens wh
en the projectile hits the ground.\015"}}{INP_R 7 0 "> "{TEXT 0 
50 "horizontal := (V, theta, t) -> V * t * cos(theta);"}}{COM_R 8
 0{TEXT 1 270 "\015(7.10)  We create a function \"vertical\" that
 returns the vertical position in meters of a projectile \"t\" se
conds after it is fired with initial speed \"V\" m/sec and initia
l angle \"theta\" radians.  This function ignores what happens wh
en the projectile hits the ground. \015"}}{INP_R 9 0 "> "{TEXT 0 
64 "vertical := (V, theta, t) -> V * t * sin(theta) - 1/2 * g * t
^2;"}}{COM_R 10 0{TEXT 1 196 "\015(7.11)  We create a function \"
duration\" that reports the time in seconds that elapses before a
 projectile fired with initial speed \"V\" m/sec and an initial a
ngle \"theta\" radians hits the ground.\015"}}{INP_R 11 0 "> "
{TEXT 0 49 "duration := (V, theta) -> 2 * V * sin(theta) / g;"}}
{COM_R 12 0{TEXT 1 55 "\015The value of g, which is acceleration \+
due to gravity.\015"}}{INP_R 13 0 "> "{TEXT 0 9 "g := 9.8;"}}
{COM_R 14 0{TEXT 1 0 ""}}{SEP_R 15 0}{SEP_R 16 0}{COM_R 17 0{TEXT
 1 222 "\015Simple two-dimensional plots.\015\015(7.27)  The firs
t parameter to this form of \"plot\" must be a symbolic expressio
n in the independent variable.  This variable is identified, and \+
its range specified, by the second parameter.\015"}}{INP_R 18 0 "
> "{TEXT 0 38 "plot(vertical(100, Pi/4, t), t=0..20);"}}{COM_R 19
 0{TEXT 1 222 "\015(7.28)  The plot from (7.27) shows the height \+
of the projectile as if it continues falling even after it hits t
he ground.  Here we specify bounds on \"time\" that correspond on
ly to the duration of the projectile's flight.\015"}}{INP_R 20 0 
"> "{TEXT 0 69 "plot(vertical(100, Pi/4, time),\012        time=0
..duration(100, Pi/4));"}}{COM_R 21 0{TEXT 1 138 "\015(7.29)  We \+
repeat (7.28), but use the \"labels\" and \"title\" options to gi
ve better labels to the axes and to include a title in the plot.\
015"}}{INP_R 22 0 "> "{TEXT 0 138 "plot(vertical(100, Pi/4, time)
,\012        time=0..duration(100, Pi/4),\012        labels=[`sec
`,  `m`],\012        title=`45 degrees; 100 m/sec`);"}}{COM_R 23 
0{TEXT 1 0 ""}}{SEP_R 24 0}{COM_R 25 0{TEXT 1 225 "\015Exercises.
\015\015(1) Produce a two-dimensional plot that shows how the ver
tical position at time 5 seconds of a projectile fired at 100 m/s
ec depends on the initial angle, as that angle varies between 30 \+
degrees and 60 degrees.\015 "}}{INP_R 26 0 "> "{TEXT 0 0 ""}}
{COM_R 27 0{TEXT 1 187 "\015(2) Produce a two-dimensional plot th
at shows how the duration of a projectile fired at 45 degrees dep
ends on the initial velocity, as that velocity varies between 0 a
nd 200 meters/sec.\015"}}{INP_R 28 0 "> "{TEXT 0 0 ""}}{COM_R 29 
0{TEXT 1 0 ""}}{SEP_R 30 0}{SEP_R 31 0}{COM_R 32 0{TEXT 1 279 "\0
15Multiple-curve plots.\015\015(7.30)  We include three different
 curves in a single plot by specifying three different dependent \+
expressions as the first parameter to \"plot\".  (The expressions
 are enclosed in braces.)  Unfortunately, two of the height curve
s extend below the ground. \015"}}{INP_R 33 0 "> "{TEXT 0 214 "pl
ot(\{vertical(100, Pi/6, t),\012          vertical(100, Pi/4, t),
\012          vertical(100, Pi/3, t)\},\012        t=0..duration(
100, Pi/3),\012        labels=[`sec`,  `m`],\012        title=`30
, 45, and 60 degrees; 100 m/sec`);"}}{COM_R 34 0{TEXT 1 0 ""}}
{COM_R 35 0{TEXT 1 137 "\015(7.31)  We repeat (7.30), but we modi
fy the three dependent expressions by using \"max\" to ensure the
ir values are never less than zero.\015"}}{INP_R 36 0 "> "{TEXT 0
 241 "plot(\{max(0, vertical(100, Pi/6, t)),\012          max(0, \+
vertical(100, Pi/4, t)),\012          max(0, vertical(100, Pi/3, \+
t))\},\012         t=0..duration(100, Pi/3),\012         labels=[
`sec`,  `m`],\012         title=`30, 45, and 60 degrees; 100 m/se
c`);"}}{COM_R 37 0{TEXT 1 0 ""}}{COM_R 38 0{TEXT 1 135 "\015(7.32
)  On the same plot, we show the horizontal and vertical position
s of a projectile fired at 100 m/sec at an angle of 45 degrees.\0
15"}}{INP_R 39 0 "> "{TEXT 0 173 "plot(\{horizontal(100, Pi/4, t)
,\012          vertical(100, Pi/4, t)\},\012         t=0..duratio
n(100, Pi/4),\012         labels=[`sec`,  `m`],\012         title
=`45 degrees; 100 m/sec`);"}}{COM_R 40 0{TEXT 1 0 ""}}{SEP_R 41 0
}{COM_R 42 0{TEXT 1 241 "\015Exercises.\015\015(3) Produce a mult
iple-curve plot showing how both the horizontal and vertical posi
tions at time five seconds of a projectile fired at 100 meters/se
c depends on the initial angle, as that angle varies between 30 a
nd 60 degrees.\015"}}{INP_R 43 0 "> "{TEXT 0 0 ""}}{COM_R 44 0
{TEXT 1 209 "\015(4) Produce a multiple-curve plot showing how th
e flight durations of two projectiles, one fired at 30 degrees an
d the other at 60 degrees, vary as their initial velocity varies \+
between 0 and 100 meters/sec.\015"}}{INP_R 45 0 "> "{TEXT 0 0 ""}
}{COM_R 46 0{TEXT 1 0 ""}}{SEP_R 47 0}{SEP_R 48 0}{COM_R 49 0
{TEXT 1 369 "\015Parametric plots.\015\015(7.33)  We create a par
ametric plot using the dependent expressions from (7.32).  We do \+
this by enclosing the two dependent expressions and the time rang
e in square brackets.  The horizontal position is plotted against
 the horizonal axis, and the vertical position is plotted against
 the vertical axis.  Time does not appear explicitly in the plot.
\015"}}{INP_R 50 0 "> "{TEXT 0 172 "plot([horizontal(100, Pi/4, t
),\012          vertical(100, Pi/4, t),\012          t=0..duratio
n(100, Pi/4)],\012         labels=[`m`,  `m`],\012         title=
`45 degrees; 100 m/sec`);"}}{COM_R 51 0{TEXT 1 229 "\015(7.34)  O
n the same plot, we put three different parametric plots.  We do \+
this by enclosing three parametric specifications (as in (7.33)) \+
in braces.  We also constrain the plot so that the scales on the \+
two axes are identical.\015"}}{INP_R 52 0 "> "{TEXT 0 440 "plot(\
{[horizontal(100, Pi/6, t),\012           vertical(100, Pi/6, t),
\012           t=0..duration(100, Pi/6)],\012          [horizonta
l(100, Pi/4, t),\012           vertical(100, Pi/4, t),\012       \+
    t=0..duration(100, Pi/4)],\012          [horizontal(100, Pi/3
, t),\012           vertical(100, Pi/3, t),\012           t=0..du
ration(100, Pi/3)]\},\012          labels=[`m`, `m`],\012        \+
  title=`30, 45, and 60 degrees; 100 m/sec`,\012          scaling
=constrained);"}}{COM_R 53 0{TEXT 1 0 ""}}{SEP_R 54 0}{COM_R 55 0
{TEXT 1 281 "\015Exercises.\015\015(5)  Produce a parametric plot
 with horizontal position on the horizontal axis and vertical pos
ition on the vertical axis.  It should show the position at time \+
five seconds of a projectile fired at 100 meters/sec as the initi
al angle varies between 30 and 60 degrees.\015"}}{INP_R 56 0 "> "
{TEXT 0 0 ""}}{COM_R 57 0{TEXT 1 283 "\015(6) Produce a parametri
c plot with horizontal position on the vertical axis and vertical
 position on the vertical axis.  It should show the position at t
ime five seconds of a projectile fired at an angle of 45 degrees \+
as the initial velocity varies between 100 and 1000 meters/sec.\0
15"}}{INP_R 58 0 "> "{TEXT 0 0 ""}}{COM_R 59 0{TEXT 1 240 "\015(7
) Produce a plot with three parametric curves.  Each curve should
 be like the one from (6) above, but one should be for an initial
 angle of 30 degrees, one for an intitial angle of 45 degrees, an
d one for an initial angle of 60 degrees.\015"}}{INP_R 60 0 "> "
{TEXT 0 0 ""}}{COM_R 61 0{TEXT 1 0 ""}}{SEP_R 62 0}{SEP_R 63 0}
{COM_R 64 0{TEXT 1 89 "\015Animation.\015\015(7.35)  Among other \+
things, this gives us access to the \"animate\" function.\015"}}
{INP_R 65 0 "> "{TEXT 0 12 "with(plots);"}}{COM_R 66 0{TEXT 1 389
 "\015(7.36)  We create an animation showing how the height of a \+
projectile depends on both time and the initial angle of its traj
ectory.  In each frame of the animation, a plot of the height of \+
the projectile against time for a particular initial angle is sho
wn.  During the animation, the initial angle varies from 0 to 90 \+
degrees.  This animation produces a series of two-dimensional plo
ts.\015"}}{INP_R 67 0 "> "{TEXT 0 203 "animate(max(0, vertical(10
0, angle, t)),\012                t=0..duration(100, Pi/2),\012  \+
              angle=0..Pi/2,\012                labels=[`sec`,  `
m`],\012                title=`0...90 degrees; 100 m/sec`);"}}
{COM_R 68 0{TEXT 1 356 "\015(7.37)  We create an animation showin
g how the trajectory of a projectile depends on both time and the
 the initial angle of its trajectory.  In each frame of the anima
tion, a parametric plot of the projectile's position is shown.  D
uring the animation, the initial angle varies from 0 to 90 degree
s.  This animation produces a series of parametric plots.\015"}}
{INP_R 69 0 "> "{TEXT 0 246 "animate([horizontal(100, angle, t),\
012                 max(0, vertical(100, angle, t)),\012         \+
        t=0..duration(100, Pi/2)],\012                angle=0..Pi
/2,\012                labels=[`m`, `m`],\012                titl
e=`0..90 degrees; 100 m/sec`);"}}{COM_R 70 0{TEXT 1 0 ""}}{SEP_R 
71 0}{COM_R 72 0{TEXT 1 336 "\015Exercises.\015\015(8) Produce an
 animation showing how the duration of a projectile's flight depe
nds on both the initial velocity and angle.  In each frame of the
 animation, a plot of the duration of the projectile's flight vs.
 initial velocity should be shown.  During the animation, the ini
tial angle should vary between 0 and 90 degrees.\015"}}{INP_R 73 
0 "> "{TEXT 0 0 ""}}{COM_R 74 0{TEXT 1 0 ""}}{SEP_R 75 0}}{END}
