{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 88{COM_R 2 0{TEXT 1 43 "Case Study: Solvin
g the Quadratic Equation\015"}}{COM_R 3 0{TEXT 1 316 "This worksh
eet is designed to accompany Chapter 6 of Introduction to Scienti
fic Programming: Computational Problem Solving Using Maple and C \+
by Joseph L. Zachary.  In it, we will use Maple to learn how to s
olve the quadratic equation in floating-point arithmetic without \+
loss of significance errors.   (AW,  Jan 97)\015"}}{SEP_R 4 0}
{SEP_R 5 0}{COM_R 6 0{TEXT 1 163 "\015Implementing the Quadratic \+
Formula.  You are no doubt familiar with the formula for solving \+
quadratic equations.  If you've forgotten what it is, Maple can h
elp.\012"}}{INP_R 7 0 "> "{TEXT 0 26 "solve(a*x^2 + b*x + c, x);"
}}{OUT_R 8 0 7{DAG ,3+3*5n3\`a`i2x0001+5n3\`b`p5*3+5*3p8j2x0002j2
x0001*5p3p11n3\`c`p11i2x0004/3p11pFp11p11p1B+3*5p3p5+5p8p5pBp5p11
p1B}}{COM_R 9 0{TEXT 1 186 "\012Let's write a pair of functions t
hat compute these two roots.   One will correspond to the first r
oot (containing the + sign), and the other to the second root (co
ntaining the - sign).\012"}}{INP_R 10 0 "> "{TEXT 0 52 "rootplus \+
:= (a,b,c) -> (-b + sqrt(b^2-4*a*c))/(2*a);"}}{OUT_R 11 0 10{DAG 
:3n5\`rootplus`@8,4n3\`a`n3\`b`n3\`c`,1,3n5\`operator`n4\`arrow`p
D+3*5+5a2x0002i2x0001(3n4\`sqrt`,2+5*3p1Aj2x0002j2x0001*5a2x0001p
28a2x0003p28i2x0004p28p28p2Bp1C/3p28p26pDpD}}{COM_R 12 0{TEXT 1 0
 ""}}{INP_R 13 0 "> "{TEXT 0 53 "rootminus := (a,b,c) -> (-b - sq
rt(b^2-4*a*c))/(2*a);"}}{OUT_R 14 0 13{DAG :3n5\`rootminus`@8,4n3
\`a`n3\`b`n3\`c`,1,3n5\`operator`n4\`arrow`pD+3*5+5a2x0002i2x0001
(3n4\`sqrt`,2+5*3p1Aj2x0002j2x0001*5a2x0001p28a2x0003p28i2x0004p1
Cp28p2Bp1C/3p28p26pDpD}}{COM_R 15 0{TEXT 1 211 "\012As a check on
 these functions, let's try to solve  x^2 + 5x + 6 = 0.   By fact
oring the left-hand side, it is easy to see that the two roots ar
e -3 and -2.  Let's confirm this with our newly created functions
.\012"}}{INP_R 16 0 "> "{TEXT 0 25 "xplus := rootplus(1,5,6);"}}
{OUT_R 17 0 16{DAG :3n4\`xplus`i2x0002}}{INP_R 18 0 "> "{TEXT 0 
27 "xminus := rootminus(1,5,6);"}}{OUT_R 19 0 18{DAG :3n4\`xminus
`i2x0003}}{COM_R 20 0{TEXT 1 103 "\012It is always good practice \+
to test functions on simple problems with known answers before us
ing them.\015"}}{SEP_R 21 0}{COM_R 22 0{TEXT 1 244 "\015Loss of S
ignificance. The problem with the quadratic formula is that, when
 using floating-point arithmetic, it may be subject to loss of si
gnificance errors of the kind discussed in Section 5.3.1 of the b
ook.  We can see this with an example.\015"}}{COM_R 23 0{TEXT 1 
129 "Suppose we wish to compute both roots of the equation x^2 + \+
2000x - 3 = 0 using floating-point numbers with ten-digit mantiss
as.\012"}}{INP_R 24 0 "> "{TEXT 0 34 "xplus := rootplus(1., 2000.
, -3.);"}}{OUT_R 25 0 24{DAG :3n4\`xplus`e3j4x001500000000i2x0012
}}{COM_R 26 0{TEXT 1 0 ""}}{INP_R 27 0 "> "{TEXT 0 36 "xminus := \+
rootminus(1., 2000., -3.);"}}{OUT_R 28 0 27{DAG :3n4\`xminus`e3i4
x002000001500i2x0006}}{COM_R 29 0{TEXT 1 98 "\012One way of check
ing these answers is to plug them back into the equation.  We sta
rt with xminus:\012"}}{INP_R 30 0 "> "{TEXT 0 27 "xminus^2 + 2000
*xminus - 3;"}}{OUT_R 31 0 30{DAG j2x0000}}{COM_R 32 0{TEXT 1 29 
"\012Quite good.  Now for xplus:\012"}}{INP_R 33 0 "> "{TEXT 0 25
 "xplus^2 + 2000*xplus - 3;"}}{OUT_R 34 0 33{DAG e3j2x2250i2x0009
}}{COM_R 35 0{TEXT 1 94 "\012Whoops.  This is not so good.  It ap
pears that xplus has not been computed accurately at all."}}
{COM_R 36 0{TEXT 1 158 "\015Here is another way to check the accu
racy of the two roots.  Repeat the above calculations of xplus an
d xminus, but user a larger value for Digits (say 20).\012"}}
{INP_R 37 0 "> "{TEXT 0 13 "Digits := 20;"}}{OUT_R 38 0 37{DAG :3
n4\`Digits`j2x0020}}{COM_R 39 0{TEXT 1 143 "\012Compare these hig
her precision values to your original answers.  What do you disco
ver?  Be sure to change Digits back to 10 before continuing\012"}
}{INP_R 40 0 "> "{TEXT 0 13 "Digits := 10;"}}{OUT_R 41 0 40{DAG :
3n4\`Digits`j2x0010}}{COM_R 42 0{TEXT 1 0 ""}}{SEP_R 43 0}{COM_R 
44 0{TEXT 1 320 "\015Explanation.  We have learned that  whereas \+
xminus has been computed  very accurately,  xplus was not compute
d accurately at all.    We lost quite a number of digits in the c
omputation of xplus.   Where did the loss of significant digits o
ccur?   To find out, let us repeat the  computations using ration
al arithmetic.\012"}}{INP_R 45 0 "> "{TEXT 0 22 "rootplus(1, 2000
, -3);"}}{OUT_R 46 0 45{DAG +5i2x1000j2x0001*3j3x01000003/3p3j2x0
002p3}}{INP_R 47 0 "> "{TEXT 0 21 "evalf(sqrt(1000003));"}}{OUT_R
 48 0 47{DAG e3j4x001000001500i2x0006}}{INP_R 49 0 "> "{TEXT 0 27
 "-1000+evalf(sqrt(1000003));"}}{OUT_R 50 0 49{DAG e3j2x1500i2x00
06}}{COM_R 51 0{TEXT 1 372 "\012It should now be clear where the \+
loss of significant digits occurred.   The number  sqrt(1000003) \+
rounds to 1000.001500.    When this gets added to the value -1000
, about six digits are cancelled.   The places of these digits ar
e taken by meaningless zeros at the end (which Maple chooses not \+
to display).   This leaves us with inadequate  precision in the f
inal answer. "}}{COM_R 52 0{TEXT 1 122 "\015Note that the same ca
ncellation of digits does not take place in the computation of  x
minus, which we can easily verify.\012"}}{INP_R 53 0 "> "{TEXT 0 
23 "rootminus(1, 2000, -3);"}}{OUT_R 54 0 53{DAG +5i2x1000j2x0001
*3j3x01000003/3p3j2x0002i2x0001}}{INP_R 55 0 "> "{TEXT 0 21 "eval
f(sqrt(1000003));"}}{OUT_R 56 0 55{DAG e3j4x001000001500i2x0006}}
{INP_R 57 0 "> "{TEXT 0 27 "-1000-evalf(sqrt(1000003));"}}{OUT_R 
58 0 57{DAG e3i4x002000001500i2x0006}}{COM_R 59 0{TEXT 1 333 "\01
2The two numbers that we are combining in the expression above ar
e of the same sign, so the leading digits are not cancelled.  If \+
b is negative, then xplus may suffer from cancellation error.  If
 b is positive, then xminus may suffer from cancellation error.  \+
This provides a clue to the remedy of the problem, which we now d
iscuss.\015"}}{SEP_R 60 0}{COM_R 61 0{TEXT 1 224 "\015Maintaining
 Significance.  The question is how to avoid the loss of signific
ance error.   First we do a bit of math.  It is easy to show, usi
ng a piece of paper or Maple, that the product of xminus and xplu
s is always c/a:\012"}}{INP_R 62 0 "> "{TEXT 0 43 "expand(rootplu
s(a,b,c) * rootminus(a,b,c));"}}{OUT_R 63 0 62{DAG *5n3\`a`i2x000
1n3\`c`j2x0001}}{COM_R 64 0{TEXT 1 129 "\012If xminus suffers fro
m cancellation errors,  xplus should be free of any such errors. \+
 In that case we could compute  xminus as\015"}}{COM_R 65 0{TEXT 
1 147 "                        xminus = (c/a) / xplus.\012\012Lik
ewise, if xplus suffers from cancellation errors, xminus should b
e ok, in which case we compute"}}{COM_R 66 0{TEXT 1 196 "\015    \+
                     xplus = (c/a) / xminus.\012\012Let us test t
his strategy by re-computing the root above which suffered from c
ancellation errors.  (Keep in mind that a = 1, b = 2000, c = -3).
\012 "}}{INP_R 67 0 "> "{TEXT 0 43 "xplusnew := (-3/1)/rootminus(
1.,2000.,-3.);"}}{OUT_R 68 0 67{DAG :3n5\`xplusnew`e3j4x001499998
875i2x0012}}{COM_R 69 0{TEXT 1 64 "\012Let's test this new root b
y plugging it back into the equation\012"}}{INP_R 70 0 "> "{TEXT 
0 31 "xplusnew^2 + 2000*xplusnew - 3;"}}{OUT_R 71 0 70{DAG j2x000
0}}{COM_R 72 0{TEXT 1 57 "\012This time, the root has been comput
ed to full precision."}}{COM_R 73 0{TEXT 1 229 "\015Here is anoth
er example, in which we solve x^2 - 1634x + 2.  Before doing any \+
Maple computations, predict whether it is xplus or xminus that wi
ll suffer from cancellation errors.  Do this by examining the sig
ns of the constants."}}{COM_R 74 0{TEXT 1 39 "\015Now we can do t
he Maple computations.\012"}}{INP_R 75 0 "> "{TEXT 0 34 "xplus :=
 rootplus(1., -1634., 2.);"}}{OUT_R 76 0 75{DAG :3n4\`xplus`e3j4x
001633998776i2x0006}}{INP_R 77 0 "> "{TEXT 0 25 "xplus^2 - 1634*x
plus + 2;"}}{OUT_R 78 0 77{DAG j2x0000}}{INP_R 79 0 "> "{TEXT 0 
36 "xminus := rootminus(1., -1634., 2.);"}}{OUT_R 80 0 79{DAG :3n
4\`xminus`e3j4x001224000000i2x0012}}{INP_R 81 0 "> "{TEXT 0 27 "x
minus^2 - 1634*xminus + 2;"}}{OUT_R 82 0 81{DAG e3i3x00014502i2x0
009}}{INP_R 83 0 "> "{TEXT 0 25 "xminusnew := (2/1)/xplus;"}}
{OUT_R 84 0 83{DAG :3n5\`xminusnew`e3j4x001223991125i2x0012}}
{INP_R 85 0 "> "{TEXT 0 33 "xminusnew^2 - 1634*xminusnew + 2;"}}
{OUT_R 86 0 85{DAG j2x0000}}{SEP_R 87 0}{COM_R 88 0{TEXT 1 376 "\
012Exercises.  In each case, compute both roots of the equation u
sing the standard quadratic formula.  Decide which root suffers f
rom cancellation errors by both (a) looking at the signs of the c
onstants and (b) plugging the computed roots back into the equati
on.  Then compute improved values of the poorly computed roots by
 following the technique suggested in this worksheet."}}{COM_R 89
 0{TEXT 1 55 "\015(a)   2x^2 - 4000x - 1 = 0\012\012(b)   5x^2 + \+
8000x + 2 = 0"}}}{END}
