{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 104{COM_R 2 0{TEXT 1 248 "Symbolic Computa
tion.\015\015This worksheet is designed to accompany Chapter 6 of
 Introduction to Scientific Programming: Computational Problem So
lving Using Maple and C by Joseph L. Zachary.  In it we will expl
ore the idea of symblic computing further.\015"}}{SEP_R 3 0}
{SEP_R 4 0}{COM_R 5 0{TEXT 1 331 "\015Introduction.  Chapter 6 on
ly hints at the support for symbolic mathematics provided by Mapl
e.  In this worksheet we will explore this support in more depth.
  The material that we will be covering here requires varying lev
els of mathematical expertise.  Feel free to skip over examples i
f you don't have the necessary background.\015"}}{SEP_R 6 0}
{SEP_R 7 0}{COM_R 8 0{TEXT 1 159 "\015Algebraic simplification.  \+
Maple's \"simplify\" function expects an expression as a paramete
r, which it simplifies.  For example, notice the difference betwe
en\015"}}{INP_R 9 0 "> "{TEXT 0 20 "sin(x)^2 + cos(x)^2;"}}{COM_R
 10 0{TEXT 1 5 "\015and\015"}}{INP_R 11 0 "> "{TEXT 0 30 "simplif
y(sin(x)^2 + cos(x)^2);"}}{SEP_R 12 0}{COM_R 13 0{TEXT 1 111 "Be \+
aware that  Maple will sometimes make unstated assumptions when d
oing simplification.  For example, compare\015"}}{INP_R 14 0 "> "
{TEXT 0 9 "16^(3/2);"}}{COM_R 15 0{TEXT 1 4 "and\015"}}{INP_R 16 
0 "> "{TEXT 0 19 "simplify(16^(3/2));"}}{COM_R 17 0{TEXT 1 67 "in
 which Maple has assumed that you want the positive square root.\
015"}}{SEP_R 18 0}{SEP_R 19 0}{COM_R 20 0{TEXT 1 448 "Equation so
lving.  Maple provides two general-purpose functions for solving \+
equations, solve and fsolve.  solve works symbolically much as yo
u do when solving equations; fsolve works numerically by repeated
ly guessing at a solution until it finds one that works.  solve i
s exact, fsolve is approximate.  For complicated equations, solve
 can be much slower than fsolve.  In fact, there are plenty of eq
uations where solve fails but fsolve succeeds.\015"}}{SEP_R 21 0}
{COM_R 22 0{TEXT 1 102 "\015solve knows all kinds of tricks for s
olving equations.  For example, it knows the quadratic formula\01
5 "}}{INP_R 23 0 "> "{TEXT 0 31 "solve(3*x^2 - 10*x + 6 = 0, x);"
}}{COM_R 24 0{TEXT 1 67 "With floating-point coefficients, we get
 floating-point solutions.\015"}}{INP_R 25 0 "> "{TEXT 0 34 "solv
e(3.*x^2 - 10.*x + 6. = 0, x);"}}{COM_R 26 0{TEXT 1 32 "Complex r
oots are also possible\015"}}{INP_R 27 0 "> "{TEXT 0 30 "solve(3*
x^2 - 4*x + 6 = 0, x);"}}{COM_R 28 0{TEXT 1 43 "The coefficients \+
can be entirely symbolic.\015"}}{INP_R 29 0 "> "{TEXT 0 30 "solve
(a*x^2 + b*x + c = 0, x);"}}{SEP_R 30 0}{COM_R 31 0{TEXT 1 91 "Ma
ple can also solve simultaneous linear equations.  Notice how set
 notation is used here.\015"}}{INP_R 32 0 "> "{TEXT 0 46 "solve(\
{3*x + 4*y = 7, 5*x + 3*y = 11\}, \{x,y\});"}}{COM_R 33 0{TEXT 1 
39 "The equations don't have to be linear.\015"}}{INP_R 34 0 "> "
{TEXT 0 46 "solve(\{3*x^2 + y = 7, 5*x + 3*y = 11\}, \{x,y\});"}}
{COM_R 35 0{TEXT 1 112 "Maple tries to keep the answer simple by \+
using the RootOf notation.  If we had used floating-point coeffic
ients\015"}}{INP_R 36 0 "> "{TEXT 0 50 "solve(\{3.*x^2 + y = 7., \+
5.*x + 3.*y = 11\}, \{x,y\});"}}{COM_R 37 0{TEXT 1 34 "This would
n't have been necessary."}}{SEP_R 38 0}{COM_R 39 0{TEXT 1 69 "It \+
is not difficult to pose an equation that solve cannot deal with.
\015"}}{INP_R 40 0 "> "{TEXT 0 23 "solve(3*cos(x) = x, x);"}}
{COM_R 41 0{TEXT 1 109 "\015If you don't need an exact or a symbo
lic solution, fsolve can solve more equations and is generally fa
ster.\015"}}{INP_R 42 0 "> "{TEXT 0 24 "fsolve(3*cos(x) = x, x);"
}}{COM_R 43 0{TEXT 1 54 "Of course, if you forget and pose a symb
olic equation\015"}}{INP_R 44 0 "> "{TEXT 0 24 "fsolve(a*cos(x) =
 x, x);"}}{COM_R 45 0{TEXT 1 29 "you'll get an error message.\015
"}}{SEP_R 46 0}{SEP_R 47 0}{COM_R 48 0{TEXT 1 100 "Calculus.  Map
le is also handy for doing calculus.  The diff function does symb
olic differentiation\015"}}{INP_R 49 0 "> "{TEXT 0 21 "diff(cos(s
in(x)), x);"}}{COM_R 50 0{TEXT 1 51 "whereas the int function doe
s symbolic integration\015"}}{INP_R 51 0 "> "{TEXT 0 28 "int(-sin
(sin(x))*cos(x), x);"}}{COM_R 52 0{TEXT 1 57 "You can also do def
inite integration by providing bounds\015"}}{INP_R 53 0 "> "{TEXT
 0 37 "int(-sin(sin(x))*cos(x), x=0..Pi/2.);"}}{COM_R 54 0{TEXT 1
 36 "It is not difficult to stump Maple.\015"}}{INP_R 55 0 "> "
{TEXT 0 20 "int(cos(sin(x)), x);"}}{COM_R 56 0{TEXT 1 140 "and th
is is how it tells you that it has failed.  In situations like th
is, trying to do a definite integral as above may be futile as we
ll.\015"}}{INP_R 57 0 "> "{TEXT 0 29 "int(cos(sin(x)), x=0..Pi/2.
);"}}{COM_R 58 0{TEXT 1 292 "In this case, if you wrap a call to \+
\"evalf\" around the call to int, Maple will do a numerical integ
ration.  This means that instead of first integration symbolicall
y and then plugging in the bounds, it will find an approximation \+
to the integral without first computing the definite integral.\01
5"}}{INP_R 59 0 "> "{TEXT 0 35 "evalf(int(cos(sin(x)), x=0..Pi/2)
);"}}{COM_R 60 0{TEXT 1 65 "It is possible to supply infinity and
 -infinity as bounds.  Thus\015"}}{INP_R 61 0 "> "{TEXT 0 24 "int
(1/x, x=0..infinity);"}}{COM_R 62 0{TEXT 1 40 "gives us an answer
 of infinity, whereas\015"}}{INP_R 63 0 "> "{TEXT 0 29 "int(1/exp
(x), x=0..infinity);"}}{COM_R 64 0{TEXT 1 26 "gives us a finite a
nswer.\015"}}{SEP_R 65 0}{SEP_R 66 0}{COM_R 67 0{TEXT 1 131 "\015
Substitutions.  Another handy feature of Maple is the ability to \+
perform substitutions.  Let's suppose that we define an equation\
015"}}{INP_R 68 0 "> "{TEXT 0 18 "eqn := cos(x) = x;"}}{COM_R 69 
0{TEXT 1 33 "which we then solve numerically.\015"}}{INP_R 70 0 "
> "{TEXT 0 23 "soln := fsolve(eqn, x);"}}{COM_R 71 0{TEXT 1 76 "W
e can substitute the value of soln for x in the original equation
 by doing\015"}}{INP_R 72 0 "> "{TEXT 0 25 "evalf(subs(x=soln, eq
n));"}}{COM_R 73 0{TEXT 1 102 "This works for any kind of express
ion--not just for equations.  For example, suppose we differentia
te\015"}}{INP_R 74 0 "> "{TEXT 0 28 "res := diff(exp(cos(x)), x);
"}}{COM_R 75 0{TEXT 1 79 "and we'd like to find out the value of \+
res when x is 1.2.  We can do that with\015"}}{INP_R 76 0 "> "
{TEXT 0 24 "evalf(subs(x=1.2, res));"}}{COM_R 77 0{TEXT 1 93 "Whe
n an equation has multiple solutions, it is possible to pick them
 out individually.  Thus\015"}}{INP_R 78 0 "> "{TEXT 0 46 "solns \+
:= solve(3.15*x^2 - 24.2*x + 15 = 0, x);"}}{COM_R 79 0{TEXT 1 48 
"We can access the first of the two solutions as\015"}}{INP_R 80 
0 "> "{TEXT 0 9 "solns[1];"}}{COM_R 81 0{TEXT 1 39 "and the secon
d of the two solutions as\015"}}{INP_R 82 0 "> "{TEXT 0 9 "solns[
2];"}}{SEP_R 83 0}{SEP_R 84 0}{COM_R 85 0{TEXT 1 210 "Vectors and
 matrices.  Vectors and matrices are used extensively in linear a
lgebra.  Maple will do all of the standard operations upon them. \+
 The first step is to make the linear algebra functions visible w
ith\015"}}{INP_R 86 0 "> "{TEXT 0 13 "with(linalg);"}}{COM_R 87 0
{TEXT 1 32 "Now we can define a vector with\015"}}{INP_R 88 0 "> \+
"{TEXT 0 21 "v := vector([1,2,3]);"}}{COM_R 89 0{TEXT 1 22 "and a
 3x3 matrix with\015"}}{INP_R 90 0 "> "{TEXT 0 39 "m := matrix(3,
 3, [1,2,3,4,5,4,3,2,1]);"}}{COM_R 91 0{TEXT 1 56 "Let's do some \+
operations upon them.  We can do addition\015"}}{INP_R 92 0 "> "
{TEXT 0 21 "add(v, v);\012add(m, m);"}}{COM_R 93 0{TEXT 1 15 "mul
tiplication\015"}}{INP_R 94 0 "> "{TEXT 0 31 "multiply(m, m);\012
multiply(m, v);"}}{COM_R 95 0{TEXT 1 16 "and dot product\015"}}
{INP_R 96 0 "> "{TEXT 0 14 "dotprod(v, v);"}}{COM_R 97 0{TEXT 1 
17 "We can transpose\015"}}{INP_R 98 0 "> "{TEXT 0 13 "transpose(
m);"}}{COM_R 99 0{TEXT 1 10 "or invert\015"}}{INP_R 100 0 "> "
{TEXT 0 46 "minverse := inverse(m);\012multiply(m, minverse);"}}
{COM_R 101 0{TEXT 1 27 "Much more is possible.  Do\015"}}{INP_R 
102 0 "> "{TEXT 0 7 "?linalg"}}{COM_R 103 0{TEXT 1 14 "\015For po
inters."}}{SEP_R 104 0}{SEP_R 105 0}}{END}
