{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 3 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 61{COM_R 2 0{TEXT 1 222 "Using Maple\015\0
15This worksheet is designed to accompany \"Introduction to Scien
tific Programming: Computational Problem Solving Using Maple and \+
C\" by Joseph L. Zachary.  In it, we explore the basics of using \+
Maple worksheets.\015"}}{SEP_R 3 0}{SEP_R 4 0}{COM_R 5 0{TEXT 1 
695 "\015This is a Maple worksheet, through which you interact wi
th Maple.  There are four key elements to a worksheet:  text (whi
ch gives information to the human reader but is ignored by Maple)
, commands (which request that Maple do some computation), result
s (which display Maple's response to your commands), and separato
r lines (which make it easier to read a worksheet).\015\015You ca
n see examples of text, commands, and separator lines in this wor
ksheet, but no results.  To obtain results, you must evaluate the
 commands that the worksheet contains.  To evaluate the command \
"2+2;\" below, click the mouse so that the cursor (a vertical bar
) is somewhere in the command and then press the Return key.\015"
}}{INP_R 6 0 "> "{TEXT 0 6 "2 + 2;"}}{OUT_R 7 0 6{DAG j2x0004}}
{SEP_R 8 0}{COM_R 9 0{TEXT 1 651 "\015Notice that when you evalua
te a command, the cursor jumps ahead to the next command so that \+
you can evaluate it.  By repeatedly pressing the Return key, you \+
will eventually evaluate all of the commands in the worksheet.  B
ut you don't have to do things in the order dictated in the works
heet, and you can even change the commands that it contains.  For
 example, instead of evaluating the command below, move the mouse
 cursor back to the command above, change the numbers that it con
tains (using the Backspace key to delete), and reevaluate it (by \+
pressing the Return key).\015\015The cursor will come back to the
 command below, which you can then evaluate\015"}}{SEP_R 10 0}
{COM_R 11 0{TEXT 1 0 ""}}{INP_R 12 0 "> "{TEXT 0 10 "sqrt(9.0);"}
}{COM_R 13 0{TEXT 1 231 "\015Generally speaking, Maple ignores an
y white space (spaces, tabs, or newlines) that you insert into a \+
command.\015\015For example, the following version of the prevoiu
s command will work just the same, although it is much less reada
ble!\015"}}{INP_R 14 0 "> "{TEXT 0 79 "sqrt          (           \+
        9.0                    )                    ;"}}{OUT_R 15
 0 14{DAG e3j4x003000000000i2x0009}}{COM_R 16 0{TEXT 1 0 ""}}
{SEP_R 17 0}{COM_R 18 0{TEXT 1 0 ""}}{COM_R 19 0{TEXT 1 232 "Of c
ourse, it won't do to put space just anywhere.  You can't put it \+
inside of a single number, and you can't put it inside of a symbo
l.  If you do that, Maple will treat your number (or symbol) as t
wo or more numbers (or symbols).\015"}}{INP_R 20 0 "> "{TEXT 0 31
 "sq    rt   (     9   .    0  );"}}{COM_R 21 0{TEXT 1 0 ""}}
{SEP_R 22 0}{COM_R 23 0{TEXT 1 0 ""}}{COM_R 24 0{TEXT 1 153 "You \+
can even use more than one line to write a command.  To insert a \+
newline into a command, use Control-M (hold down the CTRL key and
 press the M key).\015"}}{INP_R 25 0 "> "{TEXT 0 93 "1 + 2 + 3 + \+
4 + 5 + 6  + 7 + 8 + \0129 + 10 + 11 + 12 + 13 + 14 + \015 15 + 1
6 + 17 + 18 + 19 + 20;"}}{OUT_R 26 0 25{DAG j2x0210}}{SEP_R 27 0}
{COM_R 28 0{TEXT 1 0 ""}}{COM_R 29 0{TEXT 1 411 "If you forget an
d use the Return key, Maple will still put your command on more t
han one line, but it will put the \">\" prompt symbol at the begi
nning of each line.  Not only does that not look as nice, but the
re is a more serious problem lurking.  To evaluate the command, y
ou'll have to press the Return key three times.  Maple doesn't ac
tually display an answer until it encounters the terminating semi
colon.\015"}}{INP_R 30 0 "> "{TEXT 0 31 "1 + 2 + 3 + 4 + 5 + 6 + \+
7 + 8 +"}}{INP_R 31 0 "> "{TEXT 0 28 "9 + 10 + 11 + 12 + 13 + 14 \+
+"}}{INP_R 32 0 "> "{TEXT 0 28 "15 + 16 + 17 + 18 + 19 + 20;"}}
{OUT_R 33 0 32{DAG j2x0210}}{COM_R 34 0{TEXT 1 0 ""}}{COM_R 35 0
{TEXT 1 353 "If you now want to go back and reevaluate the comman
d, be sure to begin with the first line!  As an experiment, put t
he cursor on the last of the three lines of the command above and
 press Return.  You will see that only the last line is actually \+
evaluated.  If you try the same thing with the command above the \+
one above, you'll see a better behavior.\015"}}{SEP_R 36 0}{COM_R
 37 0{TEXT 1 0 ""}}{COM_R 38 0{TEXT 1 231 "You can edit a workshe
et in various ways.  You can remove text, commands, and results b
y selecting with the mouse and then choosing the \"Cut\" option f
rom the \"Edit\" menu at the top of the window.\015\015Try cuttin
g out this line of text."}}{COM_R 39 0{TEXT 1 0 ""}}{SEP_R 40 0}
{COM_R 41 0{TEXT 1 295 "\015You can delete a region of a workshee
t--an entire text area, an entire command, an entire result, or a
 separator line--by clicking the mouse in that region and then ch
oosing the \"Delete Cursor Region\" from the \"Edit\" menu.  Inst
ead of evaluating the command below, try deleting it in this way.
\015"}}{INP_R 42 0 "> "{TEXT 0 39 "Delete this command--don't eva
luate it!"}}{COM_R 43 0{TEXT 1 228 "\015When you've done that, tr
y deleting this text area and the first of the two separator line
s that follow.  It's a bit difficult to tell when you've selected
 a separator line, but there will be a small highlight at the lef
t end.\015"}}{SEP_R 44 0}{SEP_R 45 0}{COM_R 46 0{TEXT 1 588 "\015
There are some other options from the \"Edit\" menu that you can \+
experiment with.  We'll turn now to a slightly different topic.  \+
So far you have been experimenting with a worksheet that we creat
ed.  How do you create one yourself?\015\015When you first start \+
Maple, you will be looking at a blank worksheet containing a sing
le prompt, just like the one to below.  To issue a command, place
 the cursor so that it follows the prompt and type the command.  \+
Don't forget the semicolon.  When you type the \"Return\" key, th
e answer will be displayed, followed by a separator line and a fr
esh prompt.\015"}}{INP_R 47 0 "> "{TEXT 0 6 "3 * 3;"}}{COM_R 48 0
{TEXT 1 471 "\015Now you're ready to enter the next block of text
 followed by its command.  There's one problem--how do you enter \+
text when Maple has displayed its prompt and is expecting a comma
nd?  To do this, select the separator line above the prompt and c
hoose \"Insert Text\" from the \"Edit\" menu.  You can then type \+
text, which will appear below the line and before the prompt.  Wh
en you are done with the text, use the mouse to move the cursor t
o the prompt and enter the command.\015"}}{SEP_R 49 0}{COM_R 50 0
{TEXT 1 0 ""}}{INP_R 51 0 "> "{TEXT 0 0 ""}}{COM_R 52 0{TEXT 1 0 
""}}{SEP_R 53 0}{COM_R 54 0{TEXT 1 311 "\015You can also insert s
eparator lines and prompts in the same fashion.  Put the mouse cu
rsor in the region just ahead of where you want to do the inserti
on, and choose \"Insert Separator Line\" or \"Insert Prompt\" as \+
appropriate.  Try inserting a separator line between this block o
f text and the one that follows.\015"}}{COM_R 55 0{TEXT 1 529 "It
 is good practice to put comments, such as these, before each Map
le command that you issue.  Think of a worksheet as a document th
at you are writing for someone else to read.  It will be much eas
ier for your readers to understand what you did, and why you did \+
it, if you include some explanations.  It'll also make it qmuch e
asier for you to understand your own work the next time you look \+
at it.  Although it is a good idea to insert simple comments as y
ou work, you can always go back and put in more informative ones \+
later.\015"}}{SEP_R 56 0}{COM_R 57 0{TEXT 1 605 "\015When you han
d in Maple assignments, you will be handing in nicely formatted w
orksheets such as this one.  You will, of course, be needing to s
ave your worksheets.  To do that, pull down the \"File\" menu and
 choose the Save As...\" option.  A dialog box will appear into w
hich you must type the filename by which you wish to save the wor
ksheet.  You will need to type the full pathname under which you \+
wish to save the worksheet into the \"Selection\" box, and then c
lick on the \"Save\" option.  Ask for help if you don't understan
d about pathnames--it is somewhat easier to demonstrate than it i
s to explain.\015"}}{SEP_R 58 0}{COM_R 59 0{TEXT 1 254 "\015Once \+
you have saved a worksheet for the first time (or if you read it \+
in under the same name that you wish to save it), you can save it
 again by choosing the \"Save\" option from the \"File\" menu.  T
his option will do the save without asking you anything.\015"}}
{SEP_R 60 0}{COM_R 61 0{TEXT 1 609 "\015At this point you should \+
experiment with creating your own worksheet from scratch.  Experi
ment with inserting text, commands, results, and separator lines.
  When you're done, save it away to your home directory.  At that
 point, you can read in the next worksheet in the laboratory sequ
ence of quit by choosing the \"Exit\" option from the \"File\" me
nu.\015\015To obtain a blank worksheet with which to experiment, \+
choose the \"New\" option from the \"File\" menu.  Maple will ask
 you if you're sure that's what you want to do, and if you agree \+
all of this will disappear and you can start filling in the blank
 worksheet.\015"}}{SEP_R 62 0}}{END}
